---
title: 開發者手冊
type: docs
weight: 80
prev: docs/api
next: docs
sidebar:
  open: false
---


- [開發指引](./development-guidelines)
  - 分支保護與合併規範
  - Issue 與 PR 工作流程
  - 套件管理與版本控制

## 資料讀取
- [基準資料集維護](./benchmark-datasets)
  - 維護與擴充基準資料集

## 資料生成

## 資料評測
- [Anonymeter 隱私風險評測](./anonymeter)
  - 歐盟隱私風險評估標準
  - 三個面向的隱私風險量測
- [mpUCCs 實驗性新功能](./mpuccs)
  - 先進指認性風險評估
  - 最大部分唯一欄位組合理論

## 設定與報告
- [日誌設定](./logging-configuration)
  - 設定日誌層級與輸出目標
  - 自訂日誌格式與檔案位置
- [Reporter 中的實驗名稱](./experiment-naming-in-reporter)
  - 實驗命名規範
  - 實驗設定管理
- [測試覆蓋範圍](./test-coverage)
  - 測試組織與架構
  - 詳細測試案例文件

## 開發環境
- [Docker 開發](./docker-development)
  - Docker 容器開發與測試
  - 多階段建置最佳化與安全性
  - GitHub Container Registry 整合