# 🚀 v1.4.0 (2025-07-02)

本版本實現了重大功能擴展，新增 mpUCCs 隱私評估器和時間追蹤功能，同時完成 Metadater 系統的全面重構，提升系統架構的一致性和可維護性。此外，遷移至 PyPI Trusted Publishing 強化了發布流程的安全性。This release implements major feature expansions with the addition of mpUCCs privacy evaluator and timing functionality, while completing a comprehensive refactoring of the Metadater system to enhance system architecture consistency and maintainability. Additionally, migration to PyPI Trusted Publishing strengthens the security of the release process.

## ✨ 新功能 Features

### 🔐 隱私評估增強 Privacy Evaluation Enhancement
- **新增 mpUCCs 評估器** - 整合多方唯一欄位組合 (multi-party Unique Column Combinations) 評估器到 PETsARD 系統，提供更精確的隱私風險評估 integrate mpUCCs evaluator into PETsARD system for more precise privacy risk assessment (#810)

### ⏱️ 效能監控 Performance Monitoring  
- **新增時間追蹤功能** - 為 Operator 模組新增 timing 功能，提供執行時間追蹤和效能監控能力 add timing functionality to Operator module for execution time tracking and performance monitoring (#807)

### 🏗️ 系統架構重構 System Architecture Refactoring
- **Status 與 Metadater 深度整合** - 重新設計 Status 系統，與 Metadater 深度整合，改善資料狀態管理和元資料處理流程 redesign Status system with deep Metadater integration for improved data state management (#805)

- **Metadater 系統全面重構** - 採用函數式程式設計重構 Metadater 系統，淘汰舊的 metadata 和 util 模組，提升程式碼可維護性和效能 comprehensive Metadater system refactoring with functional programming approach (#800)

### 📊 資料處理改進 Data Processing Improvements
- **改善資料類型推斷** - 提升零填充代碼和可空整數的資料類型推斷準確性，增強 Loader 模組的資料處理能力 improve data type inference for zero-padded codes and nullable integers (#803)

## 🔧 重要修復 Bug Fixes

### 🔄 功能性改進 Functional Improvements
- **Splitter 重疊控制** - 實作函數式程式設計並改善重疊控制機制 implement functional programming with improved overlap control for Splitter (#806)

- **資料類型轉換** - 修復 NA 值在分類資料類型轉換中的處理問題 handle NA values in categorical dtype conversion (#796)

- **輸入驗證容錯** - 改善 Reporter 輸入驗證，優雅處理非 DataFrame 值 handle non-DataFrame values gracefully in Reporter input validation (#794)

- **約束器欄位支援** - 支援帶連字符的欄位名稱約束 support hyphenated field names in FieldConstrainer (#792)

- **編碼器缺失值處理** - 修復編碼器中缺失值的處理問題 handle missing values in encoder (#778)

- **日期時間精度** - 修正 datetime 精度和推斷類型傳播問題 correct datetime precision and inference type propagation (#798)

## 🔒 安全性與基礎設施 Security & Infrastructure

### 🛡️ 發布流程安全化 Release Process Security
- **遷移至 PyPI Trusted Publishing** - 移除 API token 依賴，啟用 attestations 進行套件完整性驗證，提升發布流程安全性 migrate to PyPI Trusted Publishing for secure automated releases

### 📦 依賴管理 Dependency Management
- **更新核心依賴** - 升級 torch 至 2.7.0+ 版本及相關依賴 update torch to 2.7.0+ and related dependencies (#784)

- **安全性依賴更新** - 更新安全性相關依賴，改善 SBOM 掃描流程 update security-related dependencies and improve SBOM scanning process

## 📚 文檔與開發體驗 Documentation & Developer Experience

### 📖 文檔完善 Documentation Enhancement
- **mpUCCs 評估器文檔** - 新增完整的 mpUCCs 評估器 API 文檔和使用指南 add comprehensive mpUCCs evaluator API documentation and usage guide

- **Metadater API 文檔** - 更新 Metadater 相關的完整 API 文檔 update comprehensive Metadater API documentation

- **示例更新** - 更新所有 demo Jupyter notebooks 以反映新功能 update all demo Jupyter notebooks to reflect new features

### 🔧 開發工具改進 Development Tools Improvement
- **Trusted Publishing 設定指南** - 新增完整的 PyPI Trusted Publishing 設定文檔 add comprehensive PyPI Trusted Publishing setup documentation

## 🧪 測試覆蓋 Testing Coverage

### ✅ 測試增強 Testing Enhancement
- **mpUCCs 測試套件** - 新增 mpUCCs 評估器的完整測試套件，確保功能穩定性 add comprehensive test suite for mpUCCs evaluator

- **系統整合測試** - 更新相關模組的測試案例，確保重構後的系統穩定性 update test cases for related modules to ensure system stability after refactoring

## 🎯 影響範圍 Impact Scope

此版本包含重大功能更新和系統架構改進，建議作為 minor 版本發布：
- ✅ 新增重要隱私評估功能
- ✅ 系統架構顯著改進  
- ✅ 向後相容性維持
- ✅ 安全性大幅提升

This release includes major feature updates and system architecture improvements, recommended as a minor version release with maintained backward compatibility and significantly enhanced security.

---

**發版負責人 Release Manager**: @matheme-justyn @alexchen830  
**發版日期 Release Date**: 2025-07-02  
**版本類型 Version Type**: Minor Release (v1.4.0)